--create table for saved variables
  rs_saved={}

  IS_RECOUNT_SKINNED = nil
  IS_FONT_REGISTERED = nil

--ACE comes with recount, no need to stress cus we are dependant :-)
--to get localized string for the MainWindowDataModes
  local AceLocale = LibStub("AceLocale-3.0")
  local L = AceLocale:GetLocale("Recount")

--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

--Write Code to make TABLE containing Recount Window Structure
--Clean up this mess BEFORE making Release

--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- CLEAN CODE FOLLOWS
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

--SLASH COMMANDS STARTS
--XXX
  local cmdCommands={["killtooltip"]=1,["simplecombatmode"]=1,["fadebars"]=1,["userecountreport"]=1}
  
  function rs_SlashCommands(cmd)
    if cmd and cmdCommands[cmd] then 
	  if rs_saved[cmd] then
	    rs_saved[cmd]=nil
	    print(" "); print("|cffffcc00Recount|rSkinByNth ->|cff888888 Toggled "..cmd.." to NOT active|r"); print(" ")
	  else
	    rs_saved[cmd]=1
	    print(" "); print("|cffffcc00Recount|rSkinByNth ->|cff888888 Toggled "..cmd.." to ACTIVE|r"); print(" ")
	  end
    else
      print(" "); print("|cffffcc00Recount|rSkinByNth ->|cff888888 No valid keyword.|r - |cffffcc00/recountskin keyword |r or |cffffcc00/rs keyword |r"); print(" ")
	  for name,_ in pairs(cmdCommands) do
	    print("|cffffcc00 -> |r"..name.." |cff888888 currently "..select(rs_saved[name] or 2,"|cffffffffACTIVE|r","NOT active").."|r")
	  end--do
	  print(" ")
    end
  end--function

  SLASH_RSBN1 = "/recountskin"
  SLASH_RSBN2 = "/rs"
  SlashCmdList.RSBN = rs_SlashCommands
--XXX
--SLASH COMMANDS ENDS

--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- DIRTY CODE FOLLOWS  - Du Not Release if code is below here
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX




	

local function RemoveAllTexturesFromFrame(frm)
  --Removes (hides) All Textures from a frame
	local Rgns = { frm:GetRegions() };
	for _, rgn in ipairs(Rgns) do
	  if rgn:IsObjectType("texture") and rgn:GetDrawLayer()~="HIGHLIGHT" then rgn:SetTexture(""); rgn:Hide() end
	end--do
end--function
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
local function FixFrameBackdrop(frm,col)
    frm:SetBackdrop({bgFile = "Interface\\AddOns\\RecountSkinByNth\\textures\\background", edgeFile = "Interface\\AddOns\\RecountSkinByNth\\textures\\border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 16, right = 16, top = 16, bottom = 16 }});
	frm:SetBackdropColor(col or 0.1, col or 0.1, col or 0.1, 1);
	frm:SetBackdropBorderColor(col or 0.1, col or 0.1, col or 0.1, 1);
end--function
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
local function FixVerticalScrollBar(scrollbar, noBg, height)
      if not noBg then
	  scrollbar:SetBackdrop({bgFile = "Interface\\AddOns\\SkinnedAlive\\tex\\menu_button_background", edgeFile = "", tile = true, tileSize = 8, edgeSize = 8, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
	  scrollbar:SetBackdropColor(0,0,0,0.25);
	  end--if
	  
	  _G[scrollbar:GetName().."ThumbTexture"]:SetTexture("Interface\\AddOns\\SkinnedAlive\\tex\\scroll_thumb_normal")
	  _G[scrollbar:GetName().."ThumbTexture"]:SetVertexColor(1,1,1,1)
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetHeight(height or 16)
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetNormalTexture("Interface\\AddOns\\SkinnedAlive\\tex\\scroll_up_normal")
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetDisabledTexture("Interface\\AddOns\\SkinnedAlive\\tex\\scroll_up_disabled")
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetPushedTexture("Interface\\AddOns\\SkinnedAlive\\tex\\scroll_up_pushed")
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetHighlightTexture("Interface\\AddOns\\SkinnedAlive\\tex\\scroll_button_highlight")
	  
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetHeight(height or 16)
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetNormalTexture("Interface\\AddOns\\SkinnedAlive\\tex\\scroll_down_normal")
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetDisabledTexture("Interface\\AddOns\\SkinnedAlive\\tex\\scroll_down_disabled")
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetPushedTexture("Interface\\AddOns\\SkinnedAlive\\tex\\scroll_down_pushed")
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetHighlightTexture("Interface\\AddOns\\SkinnedAlive\\tex\\scroll_button_highlight")
	  
	  local Rgns = { _G[scrollbar:GetName().."ScrollDownButton"]:GetRegions() };
	  for _, rgn in ipairs(Rgns) do if rgn:IsObjectType("texture") then rgn:SetVertexColor(1,1,1,1) end end--do
	  local Rgns = { _G[scrollbar:GetName().."ScrollUpButton"]:GetRegions() };
	  for _, rgn in ipairs(Rgns) do if rgn:IsObjectType("texture") then rgn:SetVertexColor(1,1,1,1) end end--do
end--function

--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
RecountMainWindowControls={}

function rs_ShowTip(self,tip)
  if not tip or rs_saved["killtooltip"] then rs_Tip:Hide(); return end
  GameTooltip:Hide()
  rs_Tip:SetScale(1)
  rs_Tip:SetPoint("BOTTOM",self,"TOP",0,0)
  rs_TipText:SetText(tip)
  rs_Tip:SetWidth(rs_TipText:GetWidth()+40)
  rs_Tip:Show()
end--function

local function ChangeRecountControlTextures(button,texture)
  button:SetHeight(16)
  local Regions = {button:GetRegions()}
    for i,Region in pairs(Regions) do
	  if i==1 then Region:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\"..texture.."_normal")end
	  if i==2 then Region:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\"..texture.."_normal")end
	  if i==3 then Region:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\"..texture.."_normal") end
	end--do
  
end--function

function rs_ReportFuntion(targetFrame)
  if rs_saved["userecountreport"] then
    if targetFrame=="Main" then
	  --show recount report window
	  Recount:ShowReport("Main", Recount.ReportData)
	else
	  print(" ");
	  print("|cffffcc00Recount|rSkinByNth ->|cff888888 Reports can only be initiated from Recounts main window when 'userecountreport' is active");
	  print("|cffffcc00Recount|rSkinByNth ->|cff888888 use |cffffcc00/rs userecountreport |r to toggle setting");
	  print(" ")
    end
  else
    if rs_ReportWindow:IsVisible() then
      rs_ReportWindow:Hide()
    else
      rs_ReportWindow.target=targetFrame;
	  rs_ReportWindow:Show()
    end
  end
end--function

function RecordRecountControls()
    local Regions = {Recount_MainWindow:GetRegions()}
	  for i,Region in pairs(Regions) do
	    if Region:IsObjectType("fontstring") then RecountMainWindowControls["TitleFontString"]=Region end
	  end
	  RecountMainWindowControls["TitleFontString"]:SetPoint("TOPLEFT",16,-14)
  if rs_saved["usefont"] then
	--local Children = {Recount_ConfigWindow.Appearance:GetChildren()}
	--  for i,Child in pairs(Children) do 
	--    if i==3 then RecountMainWindowControls["ConfigFonts"]=Child end
	--  end--do
	--  for i = 1, 13 do
	--    RecountMainWindowControls["ConfigFonts"].Rows[i].Text:SetDrawLayer("ARTWORK")
	--  end--do
  end--if  USE FONT
	local Children = {Recount_MainWindow:GetChildren()}
	  for i,Child in pairs(Children) do
	    if i==1 then RecountMainWindowControls["ExitButton"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==2 then RecountMainWindowControls["ModeButton"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==3 then RecountMainWindowControls["ScrollBar"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==4 then RecountMainWindowControls["ResizerRight"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==5 then RecountMainWindowControls["ResizerLeft"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==6 then RecountMainWindowControls["NextButton"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==7 then RecountMainWindowControls["PreviousButton"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==8 then RecountMainWindowControls["ResetButton"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==9 then RecountMainWindowControls["DataButton"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==10 then RecountMainWindowControls["ConfigButton"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
		if i==11 then RecountMainWindowControls["ReportButton"]=Child; Child:SetScript("OnLeave", function() rs_ShowTip() end) end
	  end--do
	  RecountMainWindowControls["ModeButton"]:SetScript("OnEnter", function(self,texture) rs_ShowTip(self, "Select statistic | Move") end)
	  
	  ChangeRecountControlTextures(RecountMainWindowControls["ExitButton"],"exit")
	    RecountMainWindowControls["ExitButton"]:SetScript("OnEnter", function(self,texture) rs_ShowTip(self, "Hide Recount Window") end)
	  ChangeRecountControlTextures(RecountMainWindowControls["NextButton"],"next")
	    RecountMainWindowControls["NextButton"]:SetScript("OnEnter", function(self,texture) rs_ShowTip(self, "Show next stat") end)
	  ChangeRecountControlTextures(RecountMainWindowControls["PreviousButton"],"previous")
	    RecountMainWindowControls["PreviousButton"]:SetScript("OnEnter", function(self,texture) rs_ShowTip(self, "Show previous stat") end)
	  ChangeRecountControlTextures(RecountMainWindowControls["ResetButton"],"reset")
	    RecountMainWindowControls["ResetButton"]:SetScript("OnEnter", function(self,texture) rs_ShowTip(self, "Erase data") end)
	  ChangeRecountControlTextures(RecountMainWindowControls["DataButton"],"data")
	    RecountMainWindowControls["DataButton"]:SetScript("OnEnter", function(self,texture) rs_ShowTip(self, "Select data") end)
	  ChangeRecountControlTextures(RecountMainWindowControls["ConfigButton"],"config")
	    RecountMainWindowControls["ConfigButton"]:SetScript("OnEnter", function(self,texture) rs_ShowTip(self, "Open configuration Window") end)
	  ChangeRecountControlTextures(RecountMainWindowControls["ReportButton"],"report")
	    RecountMainWindowControls["ReportButton"]:SetScript("OnEnter", function(self,texture) rs_ShowTip(self, "Initiate report") end)
		
	  
	  RecountMainWindowControls["ReportButton"]:SetScript("OnClick", function() rs_ReportFuntion("Main") end)
	  
if not MartinWantsTo then  
	  RecountMainWindowControls["ModeButton"]:SetScript("OnMouseDown", function(self,button)
	    if button=="RightButton" then
		  if rs_SelectModeWindow:IsVisible() then rs_SelectModeWindow:Hide() else rs_SelectModeWindow.target="Main"; rs_SelectModeWindow:Show() end
		else
		  local x,y=GetCursorPosition()
		  self.x=floor(x)
		  self.y=floor(y)
	      Recount_MainWindow:StartMoving()
	    end
	  end)
	  
	  RecountMainWindowControls["ModeButton"]:SetScript("OnMouseUp", function(self)
	      Recount_MainWindow:StopMovingOrSizing()
		  local x,y=GetCursorPosition()
		  if self.x==floor(x) and self.y==floor(y) then
		    if rs_SelectModeWindow:IsVisible() then rs_SelectModeWindow:Hide() else rs_SelectModeWindow.target="Main"; rs_SelectModeWindow:Show() end
		  end
		  self.x=0
		  self.y=0
	  end)
end--MartinWantsTo	  
	  
end--function

function RecountSkinByNth()
  if not IsAddOnLoaded("Recount") then return end
  print("|cffffcc00Recount|rSkinByNth") --Announce in Chatframe that Skin  is beeing applyed
  IS_RECOUNT_SKINNED=1
  --ReportWindow
    FixFrameBackdrop(rs_ReportWindow) 
    FixFrameBackdrop(rs_SelectModeWindow) 	
	FixFrameBackdrop(rs_Tip)
    CreateFrame("Button","Recount_MainWindow_Secondary",Recount_MainWindow)
	Recount_MainWindow_Secondary:SetSize(16,16)
 	Recount_MainWindow_Secondary:SetPoint("TOPLEFT",0,-12)
	Recount_MainWindow_Secondary:SetNormalTexture("Interface\\Addons\\RecountSkinByNth\\textures\\openwindow_normal")
	Recount_MainWindow_Secondary:SetHighlightTexture("Interface\\Addons\\RecountSkinByNth\\textures\\openwindow_normal")
	Recount_MainWindow_Secondary:SetScript("OnEnter", function(self,texture) rs_ShowTip(self, "Toggle secondary window") end)
	Recount_MainWindow_Secondary:SetScript("OnLeave", function() rs_ShowTip() end)
	Recount_MainWindow_Secondary:SetScript("OnClick",function() if Recount_SecondaryWindow:IsShown() then Recount_SecondaryWindow:Hide() else Recount_SecondaryWindow:Show() end end)
  --SecondaryWindow
    CreateFrame("Frame","Recount_SecondaryWindow_Background",Recount_SecondaryWindow)
	Recount_SecondaryWindow_Background:SetPoint("TOPLEFT",-12,0)
	Recount_SecondaryWindow_Background:SetPoint("BOTTOMRIGHT",12,-12)
	Recount_SecondaryWindow_Background:SetFrameLevel(Recount_SecondaryWindow:GetFrameLevel()-1)
	FixFrameBackdrop(Recount_SecondaryWindow_Background)
  --MainWindow
    RemoveAllTexturesFromFrame(Recount_MainWindow)
	CreateFrame("Frame","Recount_MainWindow_Background",Recount_MainWindow)
	Recount_MainWindow_Background:SetPoint("TOPLEFT",-12,0)
	Recount_MainWindow_Background:SetPoint("BOTTOMRIGHT",12,-12)
	Recount_MainWindow_Background:SetFrameLevel(Recount_MainWindow:GetFrameLevel()-1)
	FixFrameBackdrop(Recount_MainWindow_Background)
	FixVerticalScrollBar(Recount_MainWindow_ScrollBarScrollBar,"noBg")
	RecountResizeGripLeft:ClearAllPoints()
	RecountResizeGripLeft:SetPoint("BOTTOMLEFT",-7,-7)
	RecountResizeGripRight:ClearAllPoints()
	RecountResizeGripRight:SetPoint("BOTTOMRIGHT",7,-7)
  --barTextures
	Recount_MainWindow_Background:RegisterEvent("VARIABLES_LOADED")
	Recount_MainWindow_Background:SetScript("OnEvent", function()
	RecordRecountControls()
	  
	end)--SetScript
	Recount_MainWindow_Background:SetScript("OnUpdate", function()
	  if rs_saved["fadebars"] then
		for i=1,#Recount.MainWindow.Rows do
		    local r,g,b = Recount.MainWindow.Rows[i].StatusBar:GetStatusBarColor()
	        Recount.MainWindow.Rows[i].StatusBar:SetStatusBarColor(r,g,b,0.35)
	    end--do
	  end--fadebars
	  if rs_saved["simplecombatmode"] then
	    if UnitAffectingCombat("player") then
		  for i=1,#Recount.MainWindow.Rows do
	        Recount.MainWindow.Rows[i].RightText:SetText("")
			if not(strsub(Recount.MainWindow.Rows[i].Name or "",-strlen(UnitName("player")))==UnitName("player")) then
			  Recount.MainWindow.Rows[i].LeftText:SetText("")
			end
	      end--do
		  RecountMainWindowControls["NextButton"]:SetAlpha(0)
		  RecountMainWindowControls["PreviousButton"]:SetAlpha(0)
		  RecountMainWindowControls["ResetButton"]:SetAlpha(0)
		  RecountMainWindowControls["DataButton"]:SetAlpha(0)
		  RecountMainWindowControls["ConfigButton"]:SetAlpha(0)
		  RecountMainWindowControls["ReportButton"]:SetAlpha(0)
		else
		  --for i=1,#Recount.MainWindow.Rows do
	        --Recount.MainWindow.Rows[i].RightText:SetAlpha(0.5)
			--Recount.MainWindow.Rows[i].LeftText:SetAlpha(0.5)
	      --end--do
		  
		  RecountMainWindowControls["NextButton"]:SetAlpha(1)
		  RecountMainWindowControls["PreviousButton"]:SetAlpha(1)
		  RecountMainWindowControls["ResetButton"]:SetAlpha(1)
		  RecountMainWindowControls["DataButton"]:SetAlpha(1)
		  RecountMainWindowControls["ConfigButton"]:SetAlpha(1)
		  RecountMainWindowControls["ReportButton"]:SetAlpha(1)
		end
	  end--simplecombatmode
	end)--SetScript
--ConfigWindow
    RemoveAllTexturesFromFrame(Recount_ConfigWindow)
	CreateFrame("Frame","Recount_ConfigWindow_Background",Recount_ConfigWindow)
	Recount_ConfigWindow_Background:SetPoint("TOPLEFT",-12,0)
	Recount_ConfigWindow_Background:SetPoint("BOTTOMRIGHT",12,-12)
	Recount_ConfigWindow_Background:SetFrameLevel(Recount_ConfigWindow:GetFrameLevel()-1)
	FixFrameBackdrop(Recount_ConfigWindow_Background)
	 local Children = {Recount_ConfigWindow:GetChildren()}
	  for i,Child in pairs(Children) do
	    if i==1 then
		  Child:SetSize(16,16)
          local Regions = {Child:GetRegions()}
          for i,Region in pairs(Regions) do
	        if i==1 then Region:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\exit_normal")end
	        if i==2 then Region:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\exit_normal")end
	        if i==3 then Region:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\exit_normal") end
	      end--do
		end--if
	  end--do
--DetailWindow
    RemoveAllTexturesFromFrame(Recount_DetailWindow)
	CreateFrame("Frame","Recount_DetailWindow_Background",Recount_DetailWindow)
	Recount_DetailWindow_Background:SetPoint("TOPLEFT",-12,0)
	Recount_DetailWindow_Background:SetPoint("BOTTOMRIGHT",12,-12)
	Recount_DetailWindow_Background:SetFrameLevel(Recount_DetailWindow:GetFrameLevel()-1)
	FixFrameBackdrop(Recount_DetailWindow_Background)
	FixVerticalScrollBar(Recount_PieMode_Scrollbar2ScrollBar,"noBg")
end--function

--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
local function rs_RemoveMode(Mode)
  local i=0
  for name,_ in pairs(rs_DataModes) do
    i=i+1
    if name==Mode then tremove(rs_DataMode,i) end
  end
end


function rs_ArrangeMainWindowData(dataholder)
      dataholder.MainWindowData={}
      for i=1,#Recount.MainWindowData do
        if Recount.MainWindowData[i][1]==L["Damage Done"] 			then dataholder.MainWindowData[i]={[1]="Damage Done",			[2]= 1, [3]=L["Damage Done"]} end
		if Recount.MainWindowData[i][1]==L["DPS"] 					then dataholder.MainWindowData[i]={[1]="DPS",					[2]= 2, [3]=L["DPS"]} end
		if Recount.MainWindowData[i][1]==L["Friendly Fire"] 		then dataholder.MainWindowData[i]={[1]="Friendly Fire",			[2]= 3, [3]=L["Friendly Fire"]} end
		if Recount.MainWindowData[i][1]==L["Damage Taken"] 			then dataholder.MainWindowData[i]={[1]="Damage Taken",			[2]= 4, [3]=L["Damage Taken"]} end
		if Recount.MainWindowData[i][1]==L["Healing Done"] 			then dataholder.MainWindowData[i]={[1]="Healing Done",			[2]= 5, [3]=L["Healing Done"]} end
		if Recount.MainWindowData[i][1]==L["Absorbs"] 				then dataholder.MainWindowData[i]={[1]="Absorbs",				[2]= 6, [3]=L["Absorbs"]} end
		if Recount.MainWindowData[i][1]==L["Healing Taken"] 		then dataholder.MainWindowData[i]={[1]="Healing Taken",			[2]= 7, [3]=L["Healing Taken"]} end
		if Recount.MainWindowData[i][1]==L["Overhealing Done"]		then dataholder.MainWindowData[i]={[1]="Overhealing Done",		[2]= 8, [3]=L["Overhealing Done"]} end
		if Recount.MainWindowData[i][1]==L["Deaths"] 				then dataholder.MainWindowData[i]={[1]="Deaths",				[2]= 9, [3]=L["Deaths"]} end
		if Recount.MainWindowData[i][1]==L["DOT Uptime"] 			then dataholder.MainWindowData[i]={[1]="DOT Uptime",			[2]= 10,[3]=L["DOT Uptime"]} end
		if Recount.MainWindowData[i][1]==L["HOT Uptime"] 			then dataholder.MainWindowData[i]={[1]="HOT Uptime",			[2]= 11,[3]=L["HOT Uptime"]} end
		if Recount.MainWindowData[i][1]==L["Activity"] 				then dataholder.MainWindowData[i]={[1]="Activity",				[2]= 12,[3]=L["Activity"]} end
		if Recount.MainWindowData[i][1]==L["Dispels"] 				then dataholder.MainWindowData[i]={[1]="Dispels",				[2]= 13,[3]=L["Dispels"]} end
		if Recount.MainWindowData[i][1]==L["Dispelled"] 			then dataholder.MainWindowData[i]={[1]="Dispelled",				[2]= 14,[3]=L["Dispelled"]} end
		if Recount.MainWindowData[i][1]==L["Interrupts"] 			then dataholder.MainWindowData[i]={[1]="Interrupts",			[2]= 15,[3]=L["Interrupts"]} end
		if Recount.MainWindowData[i][1]==L["Ressers"] 				then dataholder.MainWindowData[i]={[1]="Ressers",				[2]= 16,[3]=L["Ressers"]} end
		if Recount.MainWindowData[i][1]==L["CC Breakers"] 			then dataholder.MainWindowData[i]={[1]="CC Breakers",			[2]= 17,[3]=L["CC Breakers"]} end
		if Recount.MainWindowData[i][1]==L["Mana Gained"] 			then dataholder.MainWindowData[i]={[1]="Mana Gained",			[2]= 18,[3]=L["Mana Gained"]} end
		if Recount.MainWindowData[i][1]==L["Energy Gained"] 		then dataholder.MainWindowData[i]={[1]="Energy Gained",			[2]= 19,[3]=L["Energy Gained"]} end
		if Recount.MainWindowData[i][1]==L["Rage Gained"] 			then dataholder.MainWindowData[i]={[1]="Rage Gained",			[2]= 20,[3]=L["Rage Gained"]} end
		if Recount.MainWindowData[i][1]==L["Runic Power Gained"]	then dataholder.MainWindowData[i]={[1]="Runic Power Gained",	[2]= 21,[3]=L["Runic Power Gained"]} end
	  end--do
end--function

function rs_SetReportSize(num)
	  for i=1,25 do
	    if i>num then
	      _G["rs_ReportWindowNum"..i.."On"]:Hide()
		else
		  _G["rs_ReportWindowNum"..i.."On"]:Show()
		end
	  end--do
	  rs_saved["ReportSize"]=num
	  if num<=5 then
	    rs_ReportWindowTitle:SetText("Report size |cff00ff00"..num.."|r")
	  elseif num>5 and num<=10 then
	    rs_ReportWindowTitle:SetText("Report size |cffaaff00"..num.."|r")
	  elseif num>10 and num<=15 then
	    rs_ReportWindowTitle:SetText("Report size |cffffee00"..num.."|r")
	  elseif num>15 and num<=20 then
	    rs_ReportWindowTitle:SetText("Report size |cffff9900"..num.."|r")
	  else
	    rs_ReportWindowTitle:SetText("Report size |cffff0000"..num.."|r")
	  end
end--function

function rs_InitiateReport(target,size,channel,unit)
        if channel=="REALID" then
		
		elseif channel=="WHISPER" and not unit then
		
		else
		  if target=="Main" then
		    Recount:ReportData(rs_saved["ReportSize"], channel, unit)
		  else
		    local oldmode=Recount.db.profile.MainWindowMode
			Recount:SetMainWindowMode(rs_saved["Mode"])
		    Recount:ReportData(rs_saved["ReportSize"], channel, unit)
			Recount:SetMainWindowMode(oldmode)
		  end
		  rs_ReportWindow:Hide()
        end
end--function


